﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Windows;
using System.Windows.Data;
using Infragistics.Windows.DataPresenter;

namespace MyWpfTestSolution
{
    public partial class MainWindow : Window
    {
        private static CellValueConverter cellValueConverter = new CellValueConverter();
        private static string product = "Product";
        private static string price = "Price";

        public MainWindow()
        {
            InitializeComponent();

            dGrid.FieldSettings = new FieldSettings()
            {
                CellClickAction = CellClickAction.SelectCell
            };
            dGrid.FieldLayoutSettings = new FieldLayoutSettings()
            {
                AutoGenerateFields = false,
                AllowClipboardOperations = AllowClipboardOperations.All
            };
            dGrid.FieldLayouts.Add(new FieldLayout());
            dGrid.FieldLayouts[0].Fields.Add(new Field(product, typeof(string), product));
            dGrid.FieldLayouts[0].Fields.Add(new UnboundField()
            {
                Name = price,
                BindingPath = new PropertyPath(price),
                BindingMode = BindingMode.TwoWay,
                Converter = cellValueConverter,
            });

            Random rnd = new Random();
            DataTable table = new DataTable();
            table.Columns.Add(product, typeof(string));
            table.Columns.Add(price, typeof(double));
            foreach (var productName in new List<string> { "Seafood", "Bread", "Solt" })
            {
                DataRow row = table.Rows.Add();
                row[product] = productName;
                row[price] = rnd.Next();
            }
            dGrid.DataSource = table.DefaultView;
            table.AcceptChanges();
            table.RowChanged += table_RowChanged;
        }

        private void table_RowChanged(object sender, DataRowChangeEventArgs e)
        { }
    }

    public class CellValueConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //HERE IS THE CHANGE I MADE !!!
            return Double.Parse(value.ToString());
        }
    }
}
